import json
import os
import pandas as pd
from pytube import YouTube
from youtube_transcript_api import YouTubeTranscriptApi
from pytube import YouTube
from chdir import cwd

SAVE_PATH = "video"

def downoaldYoutubeVideo(path):
    
    #create directory for each video
    with open(path, 'r') as f: # open in readonly mode
      video_list= pd.read_csv(f)
     
      for idx,row in video_list.iterrows():

            url=row['url_video']
            label=row['labeled']

            path_video = f"segment-{idx}-{label}"
            if not os.path.exists(path_video):
                os.mkdir(path_video)
            
            try: 
                my_video = YouTube(url) 
            except: 
                print("Connection Error")
            
            print("********************Download video*************************")
            #get all the stream resolution for the

            #Download video
            with cwd(path_video):
                try:
                    for stream in my_video.streams:
                        print(stream)

            #set stream resolution
                    my_video = my_video.streams.get_highest_resolution()
                    video=my_video.download(None,"video.mp4")
                    print("path video ", path_video )
                except:
                    with open("info.txt", "w") as f:
                        f.write(url)


                print("********************Download caption*************************")

                myUrl = url.split('=')
                try:
                    transcript = YouTubeTranscriptApi.get_transcript(myUrl[1], languages=['en'])
                    with open("caption.json", "w") as f:
                        json.dump(transcript, f) 
                except: 
                    print("Error - No Caption")   


    # prova video
    # http://youtube.com/watch?v=2lAe1cqCOXo

    # source
    # https://www.geeksforgeeks.org/python-downloading-captions-from-youtube/
