import nltk
import spacy

with open("keyword_generation.txt", "w") as keyword_generation:
    with open('keyword_list.txt', 'r') as f:
        keyword_list = f.read()

        nlp = spacy.load('en_core_web_sm')

        # create a Doc object
        doc = nlp(keyword_list)

        # Generate the tokens
        tokens = [token.text for token in doc]
        print(tokens)

        # Print keyword list
        print(keyword_list)
        stopwords = spacy.lang.en.stop_words.STOP_WORDS
        keyword_list.lower()

        # Generate lemmas
        lemmas = [token.lemma_ for token in doc]

        for word in lemmas:
        #print(''.join(l))
        #Convert lemmas into a string
    
            if word == "crash":
                word= '{crash|break up|go down}'
            elif word == "instance":
                word= '{instance|example}'
            elif word == "critical":
                word= '{critical|decisive}'
            elif word == "critical":
                word= '{potential|possible}'
            elif word == "bug":
                word= '{bug|glitch|bug-report}'
            elif word == "graphical":
                word= '{graphical|graphic}'
            elif word == "performance":
                word= '{performance|execution}'
            elif word == "audio":
                word= '{audio|sound}'
            elif word == "rare":
                word= '{rare|uncommon}'
            elif word == "fps":
                word= '{fps|frame rate|frame per second}'
            elif word == "minor":
                word= '{minor|small}'   
            elif word == "replication":
                word= '{replication|reproduction}'
            elif word == "stuttering":
                word= '{stuttering|stutter}'
            elif word == "ui":
                word= '{ui|user interface}'
            elif word == "drop":
                word= '{drop|drop down|drop off}'
            elif word == "occur":
                word= '{occur|happen}'
            elif word == "sync":
                word= '{sync|synchronize|synchronise}'
            elif word == "lag":
                word= '{lag|retardation|fall back}'
            elif word == "load":
                word= '{load|loading}'
            elif word == "meshing":
                word= '{meshing|mesh}'
            elif word == "error":
                word = '{error|fault|type of error}'   
            elif word == "compilation error":
                word = '{type error|compiler error|error message}'
            elif word == "list":
                word= '{list|number|listing}'
            elif word == "locig":
                word= '{locig|logical system|system}'
            elif word == "abnormal":
                word= '{abnormal|unnatural}'
            elif word == "missing":
                word= '{missing|miss|lack}'
            elif word == "correct":
                word= '{correct|right}'
            elif word == "invisible":
                word = '{invisible|unseeable}'
            elif word == "noises":
                word = '{noises|noise|disturbance}'   
            elif word == "clipping":
                word = '{clipping|clip|trim|cut back}'
            elif word == "ai":
                word = '{ai|artificial intelligence}'   
            elif word == "incorrectly":
                word = '{incorrectly|wrong|incorrect}'
            elif word == "overlap":
                word = '{overlap|intersection}'
            elif word == "distort":
                word = '{distort|deform}'
            elif word == "fail":
                word = '{fail|go bad|break}'
            elif word == "bad":
                word = '{bad|badly}'
            elif word == "overflow":
                word = '{overflow|overrun}'   
            elif word == "incorrect":
                word = '{incorrect|wrong|faulty}'
            elif word == "music":
                word = '{music|sound|audio}'   
            elif word == "duplicate":
                word = '{duplicate|replicate|matching}'
            elif word == "channeling":
                word= '{channeling|channel}'   
            elif word == "hang":
                word= '{hang|hang up}'
            elif word == "audio":
                word = '{audio|music|sound}'   
            elif word == "malfunction":
                word = '{malfunction|misfuntion}'
            elif word == "degrade":
                word = '{degrade|take down}'   
            elif word == "break":
                word = '{break|interruption|fault}'
            else:
                word
                

            keyword=" " + word
            keyword_generation.write(keyword)
keyword_generation.close()