from caption_processing import captionProcessing
from video_segmentation import videoTrimTrashold
from chdir import cwd
import numpy as np
import glob
import os
import sys


def main():
    
  if len(sys.argv) < 2:
    print("Parametri mancanti. Info: result-fold")
    print("Sto uscendo...")
    sys.exit()
  
  else:
    input_result = sys.argv[1]
    threshold = sys.argv[2]
  
  keywords=[]
  with open(os.path.abspath("generated_keyword.txt"), 'r') as keywordlist:
      lines = keywordlist.readlines()
      for i in range(len(lines)):
          line= lines[i]
          keyword=line.replace("\n","")
          keywords.append(keyword)
          
  print(keywords)
  
  for path_result in glob.glob(input_result):
    with cwd(path_result):  
      for path_video in glob.glob("v*"):
        with cwd(path_video):
          try:
            for path_segment in glob.glob("d*"):
              with cwd(path_segment):
                print("caption analysis")
                captionProcessing("caption.json")
                print("finish caption")

                print("video segmentation")
                videoTrimTrashold("caption_processing.json", keywords,threshold)
          except:
            print("no video to analyse")
            
if __name__ == "__main__":
  main()