from downloadYouTube import downoaldYoutubeVideo
from caption_processing import captionProcessing
from video_segmentation import videoTrimTrashold
from chdir import cwd
import numpy as np
import glob
import os
import sys


def main():
    
  if len(sys.argv) < 2:
    print("Parametri mancanti. Info: [input_link_file.csv] [threshold:0/5/10] [output]")
    print("Sto uscendo...")
    sys.exit()
  
  else:
    input_filename = sys.argv[1]
    threshold = sys.argv[2]
    output= sys.argv[3]
  
  keywords=[]
  with open(os.path.abspath("generated_keyword.txt"), 'r') as keywordlist:
      lines = keywordlist.readlines()
      for i in range(len(lines)):
          line= lines[i]
          keyword=line.replace("\n","")
          keywords.append(keyword)
          
  print(keywords)
  
  data_file=os.path.abspath(input_filename)
  os.mkdir(f"results-{output}")
  with cwd(f"results-{output}"):
    downoaldYoutubeVideo(data_file)
    print("finish download video")
  
    for path_video in glob.glob("s*"):
      with cwd(path_video):
        try:
              print("caption analysis")
              captionProcessing("caption.json")
              print("finish caption")

              print("video segmentation")
              videoTrimTrashold("caption_processing.json", keywords,threshold)
        except:
          print("no video to analyse")
          
if __name__ == "__main__":
  main()