#!pip install --upgrade google-api-python-client
from googleapiclient.discovery import build

api_key = 'api_key'
youtube = build('youtube', 'v3', developerKey=api_key)

def get_video_ids(youtube):
    
    
    request = youtube.search().list(
        part="id,snippet",
        type='video',
        q="bug",
        relevanceLanguage= "en",
        regionCode="US",
		    topicId= "/m/0bzvm2",		#Gaming
        videoCaption="closedCaption",
        maxResults=50
    )
    
    response = request.execute()

    video_ids = []
    
    for i in range(len(response['items'])):
        video_ids.append(response['items'][i]['id']['videoId'])
        
    next_page_token = response.get('nextPageToken')
    more_pages = True
    
    while more_pages:
        if next_page_token is None:
            more_pages = False
        else:
            request = youtube.search().list(
                        part="id,snippet",
                        type='video',
                        q="bug",
                        relevanceLanguage= "en",
                        regionCode="US",
                        topicId= "/m/0bzvm2",		#Gaming
                        videoCaption="closedCaption",
                        maxResults=50,
                        pageToken = next_page_token)
            response = request.execute()
    
            for i in range(len(response['items'])):
                video_ids.append(response['items'][i]['id']['videoId'])
            
            next_page_token = response.get('nextPageToken')
        
    return video_ids

video_ids = get_video_ids(youtube)

video_ids

print(len(video_ids))

with open ("link_video_cheater.txt", "w") as link_video:
  for video in video_ids:
    link="https://www.youtube.com/watch?v="+video+"\n"
    link_video.write(link)