# TRAINING SET

The steps are provided in isolation for allowing future researchers to replicate the results.

## 1. Keyword generation

Go to the folder `1-generation_keyword` and run `main.py`, run file with the keyword identifier following manual analysis of the dataset provided by Truelove et al. (use `keyword_list.txt`), executes the jar file for the generation of combined keywords, which were then evaluated by two annotators. The final output is a csv file containing the list of generated keywords. 

## 2.Downoald video based on  Lin et al. keyword

Run the file `2-search_video_youtube_api.py` where the query is defined based on the specific video search containing the pora key, with English subtitles and with id related to the videogames section, (enter your `api_key`).

## 3. Costruction of Training Set

Go to the folder `3-.db_download_video` and run `main.py` run file with the links to the YouTube videos (use `link_video_keyword.txt`). The list of videos can contain either the video URL (one for each line).
From an initial analysis, we obtain a csv file containing the key information about the video to be downloaded (title, description, length). This information allows us to run the random forest model trained on the traning set provided by Lin et al. to classify the video as informative (contains issues) non informative (contains no issues). Videos identified as significant gameplay videos are downloaded. 

## 4. Video Segmentation

Go to the folder `4-video_segmentation` and run `main.py`, run file with the generated keyword (`generated_keyword.txt`). The input is the folder containing the results of the videos downloaded in the previous step. For each video in the folder, the subtitles are analysed and segments containing the keyword are extracted. Start from the result folder (it will be in the format `results-{x}`, where x is the specified name).
The script will create a sub-folder for each video `segment-{t}-{labeled}` and it will place in it the video (mp4 format), json file that contain the downloaded caption and a sub-folder `segment` that contain n sub-folder based on the segment extracted. Each sub-folder `segment-{seconds}-{keyword}` contains the video segment (mp4 format) in in which the keyword was found.


